Index: django/contrib/admin/templates/admin/template_validator.html
===================================================================
--- django/contrib/admin/templates/admin/template_validator.html	(revision 8243)
+++ django/contrib/admin/templates/admin/template_validator.html	(working copy)
@@ -12,11 +12,11 @@
 
 <fieldset class="module aligned">
 <div class="form-row{% if form.site.errors %} error{% endif %} required">
-    {% if form.site.errors %}{{ form.site.html_error_list }}{% endif %}
+    {{ form.site.html_error_list }}
     <h4><label for="id_site">Site:</label> {{ form.site }}</h4>
 </div>
 <div class="form-row{% if form.template.errors %} error{% endif %} required">
-    {% if form.template.errors %}{{ form.template.html_error_list }}{% endif %}
+    {{ form.template.html_error_list }}
     <h4><label for="id_template">Template:</label> {{ form.template }}</h4>
 </div>
 </fieldset>
Index: django/contrib/admin/templates/admin/change_list.html
===================================================================
--- django/contrib/admin/templates/admin/change_list.html	(revision 8243)
+++ django/contrib/admin/templates/admin/change_list.html	(working copy)
@@ -5,7 +5,7 @@
 
 {% block bodyclass %}change-list{% endblock %}
 
-{% if not is_popup %}{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../">{% trans "Home" %}</a> &rsaquo; {{ cl.opts.verbose_name_plural|capfirst|escape }}</div>{% endblock %}{% endif %}
+{% if not is_popup %}{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../">{% trans "Home" %}</a> &rsaquo; {{ cl.opts.verbose_name_plural|capfirst }}</div>{% endblock %}{% endif %}
 
 {% block coltype %}flex{% endblock %}
 
@@ -13,7 +13,7 @@
 <div id="content-main">
 {% block object-tools %}
 {% if has_add_permission %}
-<ul class="object-tools"><li><a href="add/{% if is_popup %}?_popup=1{% endif %}" class="addlink">{% blocktrans with cl.opts.verbose_name|escape as name %}Add {{ name }}{% endblocktrans %}</a></li></ul>
+<ul class="object-tools"><li><a href="add/{% if is_popup %}?_popup=1{% endif %}" class="addlink">{% blocktrans with cl.opts.verbose_name as name %}Add {{ name }}{% endblocktrans %}</a></li></ul>
 {% endif %}
 {% endblock %}
 <div class="module{% if cl.has_filters %} filtered{% endif %}" id="changelist">
Index: django/contrib/admin/templates/admin/edit_inline/tabular.html
===================================================================
--- django/contrib/admin/templates/admin/edit_inline/tabular.html	(revision 8243)
+++ django/contrib/admin/templates/admin/edit_inline/tabular.html	(working copy)
@@ -3,13 +3,13 @@
   <div class="tabular inline-related {% if forloop.last %}last-related{% endif %}">
 {{ inline_admin_formset.formset.management_form }}
 <fieldset class="module">
-   <h2>{{ inline_admin_formset.opts.verbose_name_plural|capfirst|escape }}</h2>
+   <h2>{{ inline_admin_formset.opts.verbose_name_plural|capfirst }}</h2>
    {{ inline_admin_formset.formset.non_form_errors }}
    <table>
      <thead><tr>
      {% for field in inline_admin_formset.fields %}
        {% if not field.is_hidden %}
-         <th {% if forloop.first %}colspan="2"{% endif %}>{{ field.label|capfirst|escape }}</th>
+         <th {% if forloop.first %}colspan="2"{% endif %}>{{ field.label|capfirst }}</th>
         {% endif %}
      {% endfor %}
      {% if inline_admin_formset.formset.can_delete %}<th>{% trans "Delete" %}?</th>{% endif %}
@@ -21,7 +21,7 @@
 
         <td class="original">
           {% if inline_admin_form.original or inline_admin_form.show_url %}<p>
-          {% if inline_admin_form.original %} {{ inline_admin_form.original }}{% endif %}
+          {{ inline_admin_form.original }}
           {% if inline_admin_form.show_url %}<a href="/r/{{ inline_admin_form.original.content_type_id }}/{{ inline_admin_form.original.id }}/">View on site</a>{% endif %}
             </p>{% endif %}
           {{ inline_admin_form.pk_field.field }}
Index: django/contrib/admin/templates/admin/filter.html
===================================================================
--- django/contrib/admin/templates/admin/filter.html	(revision 8243)
+++ django/contrib/admin/templates/admin/filter.html	(working copy)
@@ -1,8 +1,8 @@
 {% load i18n %}
-<h3>{% blocktrans with title|escape as filter_title %} By {{ filter_title }} {% endblocktrans %}</h3>
+<h3>{% blocktrans with title as filter_title %} By {{ filter_title }} {% endblocktrans %}</h3>
 <ul>
 {% for choice in choices %}
     <li{% if choice.selected %} class="selected"{% endif %}>
-    <a href="{{ choice.query_string|iriencode }}">{{ choice.display|escape }}</a></li>
+    <a href="{{ choice.query_string|iriencode }}">{{ choice.display }}</a></li>
 {% endfor %}
 </ul>
Index: django/contrib/admin/templates/admin/object_history.html
===================================================================
--- django/contrib/admin/templates/admin/object_history.html	(revision 8243)
+++ django/contrib/admin/templates/admin/object_history.html	(working copy)
@@ -22,7 +22,7 @@
         {% for action in action_list %}
         <tr>
             <th scope="row">{{ action.action_time|date:_("DATE_WITH_TIME_FULL") }}</th>
-            <td>{{ action.user.username }}{% if action.user.first_name %} ({{ action.user.first_name }} {{ action.user.last_name }}){% endif %}</td>
+            <td>{{ action.user.username }}{% if action.user.get_full_name %} ({{ action.user.get_full_name }}){% endif %}</td>
             <td>{{ action.change_message }}</td>
         </tr>
         {% endfor %}
Index: django/contrib/admin/templates/admin/search_form.html
===================================================================
--- django/contrib/admin/templates/admin/search_form.html	(revision 8243)
+++ django/contrib/admin/templates/admin/search_form.html	(working copy)
@@ -4,13 +4,13 @@
 <div id="toolbar"><form id="changelist-search" action="" method="get">
 <div><!-- DIV needed for valid HTML -->
 <label for="searchbar"><img src="{% admin_media_prefix %}img/admin/icon_searchbox.png" alt="Search" /></label>
-<input type="text" size="40" name="{{ search_var }}" value="{{ cl.query|escape }}" id="searchbar" />
+<input type="text" size="40" name="{{ search_var }}" value="{{ cl.query }}" id="searchbar" />
 <input type="submit" value="{% trans 'Go' %}" />
 {% if show_result_count %}
     <span class="small quiet">{% blocktrans count cl.result_count as counter %}1 result{% plural %}{{ counter }} results{% endblocktrans %} (<a href="?{% if cl.is_popup %}pop=1{% endif %}">{% blocktrans with cl.full_result_count as full_result_count %}{{ full_result_count }} total{% endblocktrans %}</a>)</span>
 {% endif %}
 {% for pair in cl.params.items %}
-    {% ifnotequal pair.0 search_var %}<input type="hidden" name="{{ pair.0|escape }}" value="{{ pair.1|escape }}"/>{% endifnotequal %}
+    {% ifnotequal pair.0 search_var %}<input type="hidden" name="{{ pair.0 }}" value="{{ pair.1 }}"/>{% endifnotequal %}
 {% endfor %}
 </div>
 </form></div>
Index: django/contrib/admin/templates/admin/pagination.html
===================================================================
--- django/contrib/admin/templates/admin/pagination.html	(revision 8243)
+++ django/contrib/admin/templates/admin/pagination.html	(working copy)
@@ -6,6 +6,6 @@
     {% paginator_number cl i %}
 {% endfor %}
 {% endif %}
-{{ cl.result_count }} {% ifequal cl.result_count 1 %}{{ cl.opts.verbose_name|escape }}{% else %}{{ cl.opts.verbose_name_plural }}{% endifequal %}
+{{ cl.result_count }} {% ifequal cl.result_count 1 %}{{ cl.opts.verbose_name }}{% else %}{{ cl.opts.verbose_name_plural }}{% endifequal %}
 {% if show_all_url %}&nbsp;&nbsp;<a href="{{ show_all_url }}" class="showall">{% trans 'Show all' %}</a>{% endif %}
 </p>
Index: django/contrib/admin/templates/admin/auth/user/change_password.html
===================================================================
--- django/contrib/admin/templates/admin/auth/user/change_password.html	(revision 8243)
+++ django/contrib/admin/templates/admin/auth/user/change_password.html	(working copy)
@@ -8,8 +8,8 @@
 {% block breadcrumbs %}{% if not is_popup %}
 <div class="breadcrumbs">
      <a href="../../../../">{% trans "Home" %}</a> &rsaquo;
-     <a href="../../">{{ opts.verbose_name_plural|capfirst|escape }}</a> &rsaquo;
-     <a href="../">{{ original|truncatewords:"18"|escape }}</a> &rsaquo;
+     <a href="../../">{{ opts.verbose_name_plural|capfirst }}</a> &rsaquo;
+     <a href="../">{{ original|truncatewords:"18" }}</a> &rsaquo;
      {% trans 'Change password' %}
 </div>
 {% endif %}{% endblock %}
@@ -23,7 +23,7 @@
     </p>
 {% endif %}
 
-<p>{% blocktrans with original.username|escape as username %}Enter a new password for the user <strong>{{ username }}</strong>.{% endblocktrans %}</p>
+<p>{% blocktrans with original.username as username %}Enter a new password for the user <strong>{{ username }}</strong>.{% endblocktrans %}</p>
 
 <fieldset class="module aligned">
 
Index: django/contrib/admin/templates/admin/index.html
===================================================================
--- django/contrib/admin/templates/admin/index.html	(revision 8243)
+++ django/contrib/admin/templates/admin/index.html	(working copy)
@@ -59,7 +59,7 @@
             {% else %}
             <ul class="actionlist">
             {% for entry in admin_log %}
-            <li class="{% if entry.is_addition %}addlink{% endif %}{% if entry.is_change %}changelink{% endif %}{% if entry.is_deletion %}deletelink{% endif %}">{% if not entry.is_deletion %}<a href="{{ entry.get_admin_url }}">{% endif %}{{ entry.object_repr|escape }}{% if not entry.is_deletion %}</a>{% endif %}<br /><span class="mini quiet">{% filter capfirst %}{% trans entry.content_type.name %}{% endfilter %}</span></li>
+            <li class="{% if entry.is_addition %}addlink{% endif %}{% if entry.is_change %}changelink{% endif %}{% if entry.is_deletion %}deletelink{% endif %}">{% if not entry.is_deletion %}<a href="{{ entry.get_admin_url }}">{% endif %}{{ entry.object_repr }}{% if not entry.is_deletion %}</a>{% endif %}<br /><span class="mini quiet">{% filter capfirst %}{% trans entry.content_type.name %}{% endfilter %}</span></li>
             {% endfor %}
             </ul>
             {% endif %}
Index: django/contrib/admin/templates/admin/delete_confirmation.html
===================================================================
--- django/contrib/admin/templates/admin/delete_confirmation.html	(revision 8243)
+++ django/contrib/admin/templates/admin/delete_confirmation.html	(working copy)
@@ -5,21 +5,21 @@
 <div class="breadcrumbs">
      <a href="../../../../">{% trans "Home" %}</a> &rsaquo;
      <a href="../../">{{ opts.verbose_name_plural|capfirst }}</a> &rsaquo;
-     <a href="../">{{ object|escape|truncatewords:"18" }}</a> &rsaquo;
+     <a href="../">{{ object|truncatewords:"18" }}</a> &rsaquo;
      {% trans 'Delete' %}
 </div>
 {% endblock %}
 
 {% block content %}
 {% if perms_lacking %}
-    <p>{% blocktrans with object|escape as escaped_object %}Deleting the {{ object_name }} '{{ escaped_object }}' would result in deleting related objects, but your account doesn't have permission to delete the following types of objects:{% endblocktrans %}</p>
+    <p>{% blocktrans with object as escaped_object %}Deleting the {{ object_name }} '{{ escaped_object }}' would result in deleting related objects, but your account doesn't have permission to delete the following types of objects:{% endblocktrans %}</p>
     <ul>
     {% for obj in perms_lacking %}
         <li>{{ obj }}</li>
     {% endfor %}
     </ul>
 {% else %}
-    <p>{% blocktrans with object|escape as escaped_object %}Are you sure you want to delete the {{ object_name }} "{{ escaped_object }}"? All of the following related items will be deleted:{% endblocktrans %}</p>
+    <p>{% blocktrans with object as escaped_object %}Are you sure you want to delete the {{ object_name }} "{{ escaped_object }}"? All of the following related items will be deleted:{% endblocktrans %}</p>
     <ul>{{ deleted_objects|unordered_list }}</ul>
     <form action="" method="post">
     <div>
Index: django/contrib/admin/templates/admin/base.html
===================================================================
--- django/contrib/admin/templates/admin/base.html	(revision 8243)
+++ django/contrib/admin/templates/admin/base.html	(working copy)
@@ -22,22 +22,22 @@
         {% block branding %}{% endblock %}
         </div>
         {% if user.is_authenticated and user.is_staff %}
-        <div id="user-tools">{% trans 'Welcome,' %} <strong>{% if user.first_name %}{{ user.first_name|escape }}{% else %}{{ user.username }}{% endif %}</strong>. {% block userlinks %}<a href="{{ root_path }}doc/">{% trans 'Documentation' %}</a> / <a href="{{ root_path }}password_change/">{% trans 'Change password' %}</a> / <a href="{{ root_path }}logout/">{% trans 'Log out' %}</a>{% endblock %}</div>
+        <div id="user-tools">{% trans 'Welcome,' %} <strong>{% firstof user.first_name user.username %}</strong>. {% block userlinks %}<a href="{{ root_path }}doc/">{% trans 'Documentation' %}</a> / <a href="{{ root_path }}password_change/">{% trans 'Change password' %}</a> / <a href="{{ root_path }}logout/">{% trans 'Log out' %}</a>{% endblock %}</div>
         {% endif %}
         {% block nav-global %}{% endblock %}
     </div>
     <!-- END Header -->
-    {% block breadcrumbs %}<div class="breadcrumbs"><a href="/">{% trans 'Home' %}</a>{% if title %} &rsaquo; {{ title|escape }}{% endif %}</div>{% endblock %}
+    {% block breadcrumbs %}<div class="breadcrumbs"><a href="/">{% trans 'Home' %}</a>{% if title %} &rsaquo; {{ title }}{% endif %}</div>{% endblock %}
     {% endif %}
 
         {% if messages %}
-        <ul class="messagelist">{% for message in messages %}<li>{{ message|escape }}</li>{% endfor %}</ul>
+        <ul class="messagelist">{% for message in messages %}<li>{{ message }}</li>{% endfor %}</ul>
         {% endif %}
 
     <!-- Content -->
     <div id="content" class="{% block coltype %}colM{% endblock %}">
         {% block pretitle %}{% endblock %}
-        {% block content_title %}{% if title %}<h1>{{ title|escape }}</h1>{% endif %}{% endblock %}
+        {% block content_title %}{% if title %}<h1>{{ title }}</h1>{% endif %}{% endblock %}
         {% block content %}
         {% block object-tools %}{% endblock %}
         {{ content }}
Index: django/contrib/admin/templates/registration/password_reset_confirm.html
===================================================================
--- django/contrib/admin/templates/registration/password_reset_confirm.html	(revision 8243)
+++ django/contrib/admin/templates/registration/password_reset_confirm.html	(working copy)
@@ -14,9 +14,9 @@
 <p>{% trans "Please enter your new password twice so we can verify you typed it in correctly." %}</p>
 
 <form action="" method="post">
-{% if form.new_password1.errors %}{{ form.new_password1.errors }}{% endif %}
+{{ form.new_password1.errors }}
 <p class="aligned wide"><label for="id_new_password1">{% trans 'New password:' %}</label>{{ form.new_password1 }}</p>
-{% if form.new_password2.errors %}{{ form.new_password2.errors }}{% endif %}
+{{ form.new_password2.errors }}
 <p class="aligned wide"><label for="id_new_password2">{% trans 'Confirm password:' %}</label>{{ form.new_password2 }}</p>
 <p><input type="submit" value="{% trans 'Change my password' %}" /></p>
 </form>
Index: django/contrib/admin/templates/registration/password_reset_form.html
===================================================================
--- django/contrib/admin/templates/registration/password_reset_form.html	(revision 8243)
+++ django/contrib/admin/templates/registration/password_reset_form.html	(working copy)
@@ -12,7 +12,7 @@
 <p>{% trans "Forgotten your password? Enter your e-mail address below, and we'll e-mail instructions for setting a new one." %}</p>
 
 <form action="" method="post">
-{% if form.email.errors %}{{ form.email.errors }}{% endif %}
+{{ form.email.errors }}
 <p><label for="id_email">{% trans 'E-mail address:' %}</label> {{ form.email }} <input type="submit" value="{% trans 'Reset my password' %}" /></p>
 </form>
 
Index: django/contrib/admin/templates/registration/password_change_form.html
===================================================================
--- django/contrib/admin/templates/registration/password_change_form.html	(revision 8243)
+++ django/contrib/admin/templates/registration/password_change_form.html	(working copy)
@@ -13,11 +13,11 @@
 
 <form action="" method="post">
 
-{% if form.old_password.errors %}{{ form.old_password.html_error_list }}{% endif %}
+{{ form.old_password.html_error_list }}
 <p class="aligned wide"><label for="id_old_password">{% trans 'Old password:' %}</label>{{ form.old_password }}</p>
-{% if form.new_password1.errors %}{{ form.new_password1.html_error_list }}{% endif %}
+{{ form.new_password1.html_error_list }}
 <p class="aligned wide"><label for="id_new_password1">{% trans 'New password:' %}</label>{{ form.new_password1 }}</p>
-{% if form.new_password2.errors %}{{ form.new_password2.html_error_list }}{% endif %}
+{{ form.new_password2.html_error_list }}
 <p class="aligned wide"><label for="id_new_password2">{% trans 'Confirm password:' %}</label>{{ form.new_password2 }}</p>
 
 <p><input type="submit" value="{% trans 'Change my password' %}" /></p>
Index: django/contrib/admin/templates/admin_doc/template_detail.html
===================================================================
--- django/contrib/admin/templates/admin_doc/template_detail.html	(revision 8243)
+++ django/contrib/admin/templates/admin_doc/template_detail.html	(working copy)
@@ -1,18 +1,18 @@
 {% extends "admin/base_site.html" %}
 {% load i18n %}
-{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../../">Home</a> &rsaquo; <a href="../../">Documentation</a> &rsaquo; Templates &rsaquo; {{ name|escape }}</div>{% endblock %}
+{% block breadcrumbs %}<div class="breadcrumbs"><a href="../../../">Home</a> &rsaquo; <a href="../../">Documentation</a> &rsaquo; Templates &rsaquo; {{ name }}</div>{% endblock %}
 
-{% block title %}Template: {{ name|escape }}{% endblock %}
+{% block title %}Template: {{ name }}{% endblock %}
 
 {% block content %}
-<h1>Template: "{{ name|escape }}"</h1>
+<h1>Template: "{{ name }}"</h1>
 
 {% regroup templates|dictsort:"site_id" by site as templates_by_site %}
 {% for group in templates_by_site %}
-    <h2>Search path for template "{{ name|escape }}" on {{ group.grouper }}:</h2>
+    <h2>Search path for template "{{ name }}" on {{ group.grouper }}:</h2>
     <ol>
     {% for template in group.list|dictsort:"order" %}
-        <li><code>{{ template.file|escape }}</code>{% if not template.exists %} <em>(does not exist)</em>{% endif %}</li>
+        <li><code>{{ template.file }}</code>{% if not template.exists %} <em>(does not exist)</em>{% endif %}</li>
     {% endfor %}
     </ol>
 {% endfor %}
Index: django/contrib/admin/templates/admin_doc/template_tag_index.html
===================================================================
--- django/contrib/admin/templates/admin_doc/template_tag_index.html	(revision 8243)
+++ django/contrib/admin/templates/admin_doc/template_tag_index.html	(working copy)
@@ -12,7 +12,7 @@
 {% regroup tags|dictsort:"library" by library as tag_libraries %}
 {% for library in tag_libraries %}
 <div class="module">
-    <h2>{% if library.grouper %}{{ library.grouper }}{% else %}Built-in tags{% endif %}</h2>
+    <h2>{% firstof library.grouper "Built-in tags" %}</h2>
     {% if library.grouper %}<p class="small quiet">To use these tags, put <code>{% templatetag openblock %} load {{ library.grouper }} {% templatetag closeblock %}</code> in your template before using the tag.</p><hr />{% endif %}
     {% for tag in library.list|dictsort:"name" %}
     <h3 id="{{ tag.name }}">{{ tag.name }}</h3>
@@ -33,7 +33,7 @@
 {% regroup tags|dictsort:"library" by library as tag_libraries %}
 {% for library in tag_libraries %}
 <div class="module">
-    <h2>{% if library.grouper %}{{ library.grouper }}{% else %}Built-in tags{% endif %}</h2>
+    <h2>{% firstof library.grouper "Built-in tags" %}</h2>
     <ul>
     {% for tag in library.list|dictsort:"name" %}
         <li><a href="#{{ tag.name }}">{{ tag.name }}</a></li>
Index: django/contrib/admin/templates/admin_doc/view_index.html
===================================================================
--- django/contrib/admin/templates/admin_doc/view_index.html	(revision 8243)
+++ django/contrib/admin/templates/admin_doc/view_index.html	(working copy)
@@ -29,7 +29,7 @@
 
 {% for view in site_views.list|dictsort:"url" %}
 {% ifchanged %}
-<h3><a href="{{ view.module }}.{{ view.name }}/">{{ view.url|escape }}</a></h3>
+<h3><a href="{{ view.module }}.{{ view.name }}/">{{ view.url }}</a></h3>
 <p class="small quiet">View function: {{ view.module }}.{{ view.name }}</p>
 <p>{{ view.title }}</p>
 <hr />
Index: django/contrib/admin/templates/admin_doc/model_detail.html
===================================================================
--- django/contrib/admin/templates/admin_doc/model_detail.html	(revision 8243)
+++ django/contrib/admin/templates/admin_doc/model_detail.html	(working copy)
@@ -34,7 +34,7 @@
 <tr>
     <td>{{ field.name }}</td>
     <td>{{ field.data_type }}</td>
-    <td>{% if field.verbose %}{{ field.verbose }}{% endif %}{% if field.help_text %} - {{ field.help_text|safe }}{% endif %}</td>
+    <td>{{ field.verbose }}{% if field.help_text %} - {{ field.help_text|safe }}{% endif %}</td>
 </tr>
 {% endfor %}
 </tbody>
Index: django/contrib/admin/templates/admin_doc/template_filter_index.html
===================================================================
--- django/contrib/admin/templates/admin_doc/template_filter_index.html	(revision 8243)
+++ django/contrib/admin/templates/admin_doc/template_filter_index.html	(working copy)
@@ -12,7 +12,7 @@
 {% regroup filters|dictsort:"library" by library as filter_libraries %}
 {% for library in filter_libraries %}
 <div class="module">
-    <h2>{% if library.grouper %}{{ library.grouper }}{% else %}Built-in filters{% endif %}</h2>
+    <h2>{% firstof library.grouper "Built-in filters" %}</h2>
     {% if library.grouper %}<p class="small quiet">To use these filters, put <code>{% templatetag openblock %} load {{ library.grouper }} {% templatetag closeblock %}</code> in your template before using the filter.</p><hr />{% endif %}
     {% for filter in library.list|dictsort:"name" %}
     <h3 id="{{ filter.name }}">{{ filter.name }}</h3>
@@ -33,7 +33,7 @@
 {% regroup filters|dictsort:"library" by library as filter_libraries %}
 {% for library in filter_libraries %}
 <div class="module">
-    <h2>{% if library.grouper %}{{ library.grouper }}{% else %}Built-in filters{% endif %}</h2>
+    <h2>{% firstof library.grouper "Built-in filters" %}</h2>
     <ul>
     {% for filter in library.list|dictsort:"name" %}
         <li><a href="#{{ filter.name }}">{{ filter.name }}</a></li>