Index: django/conf/locale/de/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/de/LC_MESSAGES/django.po	(revision 8255)
+++ django/conf/locale/de/LC_MESSAGES/django.po	(working copy)
@@ -8,8 +8,8 @@
 "Project-Id-Version: Django\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2008-08-01 11:38+0200\n"
-"PO-Revision-Date: 2008-08-01 12:42+0100\n"
-"Last-Translator: Jannis Leidel <jannis@leidel.info>\n"
+"PO-Revision-Date: 2008-08-09 16:44+0100\n"
+"Last-Translator: Benjamin Schwarze <benjixx@abbre.de>\n"
 "Language-Team: \n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
@@ -404,7 +404,7 @@
 #: contrib/admin/sites.py:240
 #: contrib/admin/views/decorators.py:75
 msgid "Looks like your browser isn't configured to accept cookies. Please enable cookies, reload this page, and try again."
-msgstr "Es sieht danach aus, dass der Browser keine Cookies akzeptiert. Bitte im Browser Cookies aktivieren und diese Seite neu laden."
+msgstr "Ihr Browser scheint keine Cookies zu akzeptieren. Bitte aktivieren Sie diese und laden Sie die Seite neu."
 
 #: contrib/admin/sites.py:254
 #: contrib/admin/sites.py:260
@@ -496,7 +496,7 @@
 
 #: contrib/admin/templates/admin/500.html:10
 msgid "There's been an error. It's been reported to the site administrators via e-mail and should be fixed shortly. Thanks for your patience."
-msgstr "Ein Fehler ist aufgetreten. Dieser Fehler wurde an die Serververwalter per E-Mail weitergegeben und sollte bald behoben sein. Vielen Dank für Ihr Verständnis."
+msgstr "Ein Fehler ist aufgetreten. Dieser Fehler wurde an die Serververwalter per E-Mail gemeldet und sollte in Kürze behoben sein. Vielen Dank für Ihr Verständnis."
 
 #: contrib/admin/templates/admin/base.html:25
 msgid "Welcome,"
@@ -576,7 +576,7 @@
 #: contrib/admin/templates/admin/delete_confirmation.html:22
 #, python-format
 msgid "Are you sure you want to delete the %(object_name)s \"%(escaped_object)s\"? All of the following related items will be deleted:"
-msgstr "Sind Sie sicher, dass Sie %(object_name)s \"%(escaped_object)s\" löschen wollen? Es werden zusätzlich die folgenden abhängigen Daten mit gelöscht:"
+msgstr "Sind Sie sicher, dass Sie %(object_name)s \"%(escaped_object)s\" löschen wollen? Es werden zusätzlich die folgenden abhängigen Daten gelöscht:"
 
 #: contrib/admin/templates/admin/delete_confirmation.html:27
 msgid "Yes, I'm sure"
@@ -744,8 +744,8 @@
 "<p class=\"help\">Um Bookmarklets zu installieren, müssen diese Links in die\n"
 "Browser-Werkzeugleiste gezogen werden, oder mittels rechter Maustaste in die\n"
 "Bookmarks gespeichert werden. Danach können die Bookmarklets von jeder Seite\n"
-"aufgerufen werden. Einige Bookmarklets sind für den Zugriff von 'internen'\n"
-"Rechnern eingeschränkt. Falls nicht klar ist, ob ein Rechner als 'intern'\n"
+"aufgerufen werden. Einige Bookmarklets sind auf den Zugriff von 'internen'\n"
+"Rechnern beschränkt. Falls nicht klar ist, ob ein Rechner als 'intern'\n"
 "bewertet wird, bitte den Administrator fragen.</p>\n"
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:18
@@ -754,7 +754,7 @@
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:19
 msgid "Jumps you from any page to the documentation for the view that generates that page."
-msgstr "Springt von jeder Seite zu der Dokumentation für den View der diese Seite erzeugt."
+msgstr "Springt von jeder Seite zu der Dokumentation für den View, der diese Seite erzeugt."
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:21
 msgid "Show object ID"
@@ -762,11 +762,11 @@
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:22
 msgid "Shows the content-type and unique ID for pages that represent a single object."
-msgstr "Zeigt den Content-Type und die eindeutige ID für Seiten die ein einzelnes Objekt repräsentieren."
+msgstr "Zeigt den Content-Type und die eindeutige ID für Seiten, die ein einzelnes Objekt repräsentieren."
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:24
 msgid "Edit this object (current window)"
-msgstr "Dieses Objekt im aktuellen Fenster ändern."
+msgstr "Dieses Objekt ändern (Aktives Fenster)"
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:25
 msgid "Jumps to the admin page for pages that represent a single object."
@@ -774,7 +774,7 @@
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:27
 msgid "Edit this object (new window)"
-msgstr "Dieses Objekt in einem neuen Fenster ändern."
+msgstr "Dieses Objekt ändern (Neues Fenster)"
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:28
 msgid "As above, but opens the admin page in a new window."
@@ -872,7 +872,7 @@
 
 #: contrib/admin/templates/registration/password_reset_done.html:12
 msgid "We've e-mailed you instructions for setting your password to the e-mail address you submitted. You should be receiving it shortly."
-msgstr "Wir haben Ihnen eine E-Mail mit Anweisungen zum Zurücksetzen Ihres Passwort an die von Ihnen angegebene E-Mail-Adresse geschickt. Sie sollten sie in Kürze erhalten."
+msgstr "Wir haben Ihnen eine E-Mail mit Anweisungen zum Zurücksetzen Ihres Passwort an die von Ihnen angegebene E-Mail-Adresse geschickt. Sie sollten diese in Kürze erhalten."
 
 #: contrib/admin/templates/registration/password_reset_email.html:2
 msgid "You're receiving this e-mail because you requested a password reset"
@@ -1033,7 +1033,7 @@
 
 #: contrib/admindocs/views.py:327
 msgid "Floating point number"
-msgstr "Fließkommazahl"
+msgstr "Gleitkommazahl"
 
 #: contrib/admindocs/views.py:331
 #: contrib/comments/models.py:89
@@ -1076,7 +1076,7 @@
 #: contrib/admindocs/views.py:370
 #, python-format
 msgid "%s does not appear to be a urlpattern object"
-msgstr "%s ist scheinbar kein urlpattern Objekt"
+msgstr "%s ist scheinbar kein urlpattern-Objekt"
 
 #: contrib/auth/admin.py:17
 msgid "Personal info"
@@ -1101,7 +1101,7 @@
 #: contrib/auth/forms.py:15
 #: contrib/auth/models.py:134
 msgid "Required. 30 characters or fewer. Alphanumeric characters only (letters, digits and underscores)."
-msgstr "Erforderlich. 30 Zeichen oder weniger. Alphanumerische Zeichen (Buchstaben, Ziffern und Unterstriche sind erlaubt)."
+msgstr "Erforderlich. 30 Zeichen oder weniger. Nur alphanumerische Zeichen (Buchstaben, Ziffern und Unterstriche) sind erlaubt."
 
 #: contrib/auth/forms.py:16
 #: core/validators.py:72
@@ -1114,7 +1114,7 @@
 
 #: contrib/auth/forms.py:30
 msgid "A user with that username already exists."
-msgstr "Ein Benutzer mit diesem Namen existiert bereits."
+msgstr "Dieser Benutzername ist bereits vergeben."
 
 #: contrib/auth/forms.py:36
 #: contrib/auth/forms.py:146
@@ -1138,7 +1138,7 @@
 
 #: contrib/auth/forms.py:101
 msgid "That e-mail address doesn't have an associated user account. Are you sure you've registered?"
-msgstr "Zu dieser E-Mail-Adresse existiert kein Benutzer. Sicher, dass Sie sich mit dieser Adresse angemeldet haben?"
+msgstr "Zu dieser E-Mail-Adresse existiert kein Benutzer. Sicher, dass Sie sich mit dieser Adresse registriert haben?"
 
 #: contrib/auth/forms.py:126
 #, python-format
@@ -1230,7 +1230,7 @@
 
 #: contrib/auth/models.py:141
 msgid "superuser status"
-msgstr "Hauptadmin"
+msgstr "Haupt-Admin"
 
 #: contrib/auth/models.py:141
 msgid "Designates that this user has all permissions without explicitly assigning them."
@@ -3542,7 +3542,7 @@
 
 #: contrib/redirects/models.py:9
 msgid "redirect to"
-msgstr "Umleitung zu"
+msgstr "Umleitung nach"
 
 #: contrib/redirects/models.py:10
 msgid "This can be either an absolute path (as above) or a full URL starting with 'http://'."
@@ -3586,11 +3586,11 @@
 
 #: contrib/sites/models.py:38
 msgid "site"
-msgstr "Website"
+msgstr "Webseite"
 
 #: contrib/sites/models.py:39
 msgid "sites"
-msgstr "Websites"
+msgstr "Webseiten"
 
 #: core/validators.py:76
 msgid "This value must contain only letters, numbers, underscores, dashes or slashes."
@@ -3668,7 +3668,7 @@
 #: core/validators.py:470
 #: forms/fields.py:430
 msgid "No file was submitted. Check the encoding type on the form."
-msgstr "Es wurde keine Datei übermittelt. Eventuell ist das Formular-Encoding falsch."
+msgstr "Es wurde keine Datei übermittelt. Überprüfen Sie das Encoding des Formulars."
 
 #: core/validators.py:189
 #: forms/fields.py:470
@@ -3692,7 +3692,7 @@
 
 #: core/validators.py:212
 msgid "A valid URL is required."
-msgstr "Eine gültige URL wird hier verlangt."
+msgstr "Eine gültige URL ist erforderlich."
 
 #: core/validators.py:226
 #, python-format
@@ -3717,7 +3717,7 @@
 #: core/validators.py:257
 #, python-format
 msgid "The URL %s is a broken link."
-msgstr "Die URL %s funktioniert nicht."
+msgstr "Die URL %s ist nicht erreichbar."
 
 #: core/validators.py:263
 msgid "Enter a valid U.S. state abbreviation."
@@ -3805,7 +3805,7 @@
 
 #: core/validators.py:454
 msgid "Please enter a valid floating point number."
-msgstr "Bitte eine gültige Dezimalzahl eingeben."
+msgstr "Bitte eine gültige Gleitkommazahl eingeben."
 
 #: core/validators.py:463
 #, python-format
@@ -4390,7 +4390,7 @@
 #: views/generic/create_update.py:214
 #, python-format
 msgid "The %(verbose_name)s was deleted."
-msgstr "%(verbose_name)s wurde gelöscht"
+msgstr "%(verbose_name)s wurde gelöscht."
 
 #~ msgid "Ordering"
 #~ msgstr "Sortierung"